LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY ADD_DEC IS
	PORT
	(
		SA					: IN	STD_LOGIC_VECTOR(15 DOWNTO 1);
		LCD_ADD0,LCD_ADD1	: OUT 	STD_LOGIC;
		MPC_ADD0,MPC_ADD1	: OUT	STD_LOGIC;
		AMC_ADD				: OUT	STD_LOGIC;
		RE_ADD0,RE_ADD1		: OUT	STD_LOGIC;
		USS_ADD0,USS_ADD1	: OUT	STD_LOGIC;
		TLP_ADD0,TLP_ADD1	: OUT	STD_LOGIC;
		IRS_ADD,IRS_RS		: OUT   STD_LOGIC;
		AEN					: IN   STD_LOGIC;
		IOCS16n				: OUT	STD_LOGIC
	);
END ADD_DEC;

ARCHITECTURE DATAFLOW OF ADD_DEC IS
SIGNAL TEMP : STD_LOGIC_VECTOR(15 downto 0);
BEGIN
TEMP<=AEN & SA(15 downto 1);
LCD_ADD1 <= SA(1);
PROCESS (TEMP)
BEGIN
	CASE TEMP IS
--0100h or 0102h
		WHEN "0000000010000000"
			|"0000000010000001"	=>	LCD_ADD0 	<= '1';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TLP_ADD0 	<= '0';
									TLP_ADD1 	<= '0';
									AMC_ADD 	<= '0';
									IRS_ADD		<= '0';
									IRS_RS		<= '0';
									IOCS16n 	<= '1';
--0110h
		WHEN "0000000010001000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '1';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TLP_ADD0 	<= '0';
									TLP_ADD1 	<= '0';
									AMC_ADD 	<= '0';
									IRS_ADD		<= '0';
									IRS_RS		<= '0';
									IOCS16n 	<= '1';
--0112h
		WHEN "0000000010001001"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '1';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TLP_ADD0 	<= '0';
									TLP_ADD1 	<= '0';
									AMC_ADD 	<= '0';
									IRS_ADD		<= '0';
									IRS_RS		<= '0';
									IOCS16n 	<= '1';
--0120h
		WHEN "0000000010010000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '1';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TLP_ADD0 	<= '0';
									TLP_ADD1 	<= '0';
									AMC_ADD 	<= '0';
									IRS_ADD		<= '0';
									IRS_RS		<= '0';
									IOCS16n 	<= '1';
--0122h
		WHEN "0000000010010001"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '1';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TLP_ADD0 	<= '0';
									TLP_ADD1 	<= '0';
									AMC_ADD 	<= '0';
									IRS_ADD		<= '0';
									IRS_RS		<= '0';
									IOCS16n 	<= '1';
--0130h
		WHEN "0000000010011000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '1';
									USS_ADD1 	<= '0';
									TLP_ADD0 	<= '0';
									TLP_ADD1 	<= '0';
									AMC_ADD 	<= '0';
									IRS_ADD		<= '0';
									IRS_RS		<= '0';
									IOCS16n 	<= '1';
--0132h
		WHEN "0000000010011001"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '1';
									TLP_ADD0 	<= '0';
									TLP_ADD1 	<= '0';
									AMC_ADD 	<= '0';
									IRS_ADD		<= '0';
									IRS_RS		<= '0';
									IOCS16n 	<= '1';
--0140h
		WHEN "0000000010100000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TLP_ADD0 	<= '1';
									TLP_ADD1 	<= '0';
									AMC_ADD 	<= '0';
									IRS_ADD		<= '0';
									IRS_RS		<= '0';
									IOCS16n 	<= '1';
--0142h
		WHEN "0000000010100001"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TLP_ADD0 	<= '0';
									TLP_ADD1 	<= '1';
									AMC_ADD 	<= '0';
									IRS_ADD		<= '0';
									IRS_RS		<= '0';
									IOCS16n 	<= '1';
--0150h
		WHEN "0000000010101000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TLP_ADD0 	<= '0';
									TLP_ADD1 	<= '0';
									AMC_ADD 	<= '1';
									IRS_ADD		<= '0';
									IRS_RS		<= '0';
									IOCS16n 	<= '1';
--0160h
		WHEN "0000000010110000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TLP_ADD0 	<= '0';
									TLP_ADD1 	<= '0';
									AMC_ADD 	<= '0';
									IRS_ADD		<= '1';
									IRS_RS		<= '0';
									IOCS16n 	<= '1';
--0162h
		WHEN "0000000010110001"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TLP_ADD0 	<= '0';
									TLP_ADD1 	<= '0';
									AMC_ADD 	<= '0';
									IRS_ADD		<= '0';
									IRS_RS		<= '1';
									IOCS16n 	<= '1';

		WHEN OTHERS				=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									USS_ADD0 	<= '0';
									USS_ADD1 	<= '0';
									TLP_ADD0 	<= '0';
									TLP_ADD1 	<= '0';
									AMC_ADD 	<= '0';
									IRS_ADD		<= '0';
									IRS_RS		<= '0';
									IOCS16n 	<= '0';
	END CASE;
END PROCESS;
END DATAFLOW;

