LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY AMC_LATCH IS
	PORT
	(
		B_SD		: IN	STD_LOGIC_VECTOR(1 downto 0);
		B_IOWN		: IN	STD_LOGIC;
		B_RESET		: IN	STD_LOGIC;
		AMC_ADD		: IN	STD_LOGIC;
		DIR0		: OUT	STD_LOGIC;
		DIR1		: OUT	STD_LOGIC);
END AMC_LATCH;

ARCHITECTURE RTL OF AMC_LATCH IS
	SIGNAL	WRITE	: STD_LOGIC;
begin
WRITE <= AMC_ADD and not B_IOWN;
process(WRITE,B_RESET)
begin
	if (B_RESET='1') then
		DIR0 <= '0';
		DIR1 <= '0';
	else
		if (WRITE'event and WRITE='1') then
				DIR0 <= B_SD(0);
				DIR1 <= B_SD(1);
		end if;
	end if;
end process;
end RTL;

