-- DATA LATCH MODULE	Produced by Simamu
--						Ver1.0 2000.09.07
--						Ver2.0 2000.10.19
--						Vwe2.1 2000.10.26

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY TIP_LATCH IS
	PORT
	(
		TIPIN				: IN	STD_LOGIC_VECTOR(15 DOWNTO 0);
		MASK				: IN	STD_LOGIC;
		RESET				: IN	STD_LOGIC;
		TIP_ADD0,TIP_ADD1	: IN	STD_LOGIC;
		B_IOWN				: IN	STD_LOGIC;
		B_RESET				: IN	STD_LOGIC;
		B_CLK				: IN	STD_LOGIC;
		TIPOUT				: OUT 	STD_LOGIC_VECTOR(15 DOWNTO 0);
		IRQ					: OUT	STD_LOGIC
	);
END TIP_LATCH;

ARCHITECTURE RTL OF TIP_LATCH IS
	SIGNAL	TIPDUM	: STD_LOGIC_VECTOR(15 DOWNTO 0);
	SIGNAL	IRQDUM	: STD_LOGIC;
	SIGNAL	MASKDUM	: STD_LOGIC;
BEGIN
	PROCESS (B_CLK,B_RESET)
	BEGIN
		IF (B_RESET /= '0')
		THEN	TIPDUM <= "0000000000000000";
				IRQDUM <= '0';
				MASKDUM <= '1';
		ELSE	IF (B_CLK'EVENT AND B_CLK = '1')
				THEN	IF (TIP_ADD1 = '1' AND B_IOWN = '0')
						THEN	MASKDUM <= MASK;
								IRQDUM <= IRQDUM AND (NOT RESET);
						ELSE	IF (TIP_ADD0 = '0' AND TIPIN /= TIPDUM)
								THEN	IRQDUM <= '1';
										TIPDUM <= TIPIN;
								END IF;
						END IF;
				END IF;
		END IF;
	END PROCESS;
IRQ <= IRQDUM AND (NOT MASKDUM); 
TIPOUT <= TIPDUM;
END RTL;

